%% Shapes for detection on the graph defined on unit square

% Shape: circular disk
I = (sqrt((c(:, 1)-0.5).^2 + (c(:, 2)-0.5).^2) < 0.3) + 0;
% Shape: square
I = (max(abs(c(:, 1)-0.5), abs(c(:, 2)-0.5)) < 0.2) + 0;
% Shape: triangle
I = (c(:, 2)-0.3 > 0 & c(:, 2) - c(:, 1) < 0.1 & c(:, 2) + c(:, 1) < 1.1) + 0;
% Shape: big square
I = (max(abs(c(:, 1)-0.5), abs(c(:, 2)-0.5)) < 0.3) + 0;
% Shape: big triangle
I = (c(:, 2)-0.25 > 0 & c(:, 2) - 1.5*c(:, 1) < 0.1 &...
    c(:, 2) + 1.5*c(:, 1) < 1.6) + 0;
% Shapes: triangle, square, ellipse
triangle = (c(:, 2)-0.6 > 0 & c(:, 2) - c(:, 1) < 0.5 & c(:, 2) + c(:, 1) < 0.9);
ellipse = ((c(:, 1)-0.6).^2/(0.15^2) + (c(:, 2)-0.7).^2/(0.1^2) < 1);
square = (max(abs(c(:, 1)-0.5), abs(c(:, 2)-0.25)) < 0.15);
I = (triangle | ellipse | square) + 0;
% Shapes: circle and two squares
circle = (sqrt((c(:, 1)-0.5).^2 + (c(:, 2)-0.75).^2) < 0.2);
square1 = (max(abs(c(:, 1)-0.25), abs(c(:, 2)-0.25)) < 0.15);
square2 = (max(abs(c(:, 1)-0.75), abs(c(:, 2)-0.25)) < 0.15);
I = (circle | square1 | square2) + 0;
% Shapes: two circles
circle1 = (sqrt((c(:, 1)-0.33).^2 + (c(:, 2)-0.33).^2) < 0.15);
circle2 = (sqrt((c(:, 1)-0.67).^2 + (c(:, 2)-0.67).^2) < 0.15);
I = (circle1 | circle2) + 0;
% Shapes: two close circles
circle1 = (sqrt((c(:, 1)-0.37).^2 + (c(:, 2)-0.37).^2) < 0.15);
circle2 = (sqrt((c(:, 1)-0.63).^2 + (c(:, 2)-0.63).^2) < 0.15);
I = (circle1 | circle2) + 0;
